Index: src/core/ctrl/tsp_group_algo.c
===================================================================
--- src/core/ctrl/tsp_group_algo.c	(révision 4)
+++ src/core/ctrl/tsp_group_algo.c	(révision 205)
@@ -38,7 +38,11 @@
  */
 
 #include <string.h>
-
+#ifdef WIN32
+    #define assert(exp)     ((void)0)
+#else
+    #include <assert.h>
+#endif
 #include "tsp_sys_headers.h"
 
 #include "tsp_group_algo.h"
@@ -233,7 +237,7 @@
 
     }
       
-  STRACE_DEBUG(("Max group size = %d", table->max_group_len));
+  STRACE_INFO(("Max group size = %d", table->max_group_len));
   return table;
 }
                                                              
@@ -303,9 +307,10 @@
 		table->groups[group_id].items[rank].offset       = in_info->offset;
 		table->groups[group_id].items[rank].nelem        = in_info->nelem;
 		
-		/*complete les infos)*/		  
+		/*complete les infos)*/
+        /* cast en int32_t pour Windows : WIN32 */
 		table->groups[group_id].items[rank].data = 
-		  TSP_datapool_get_symbol_value(datapool, in_info->provider_global_index)
+		  (int32_t)TSP_datapool_get_symbol_value(datapool, in_info->provider_global_index)
 		  + in_info->offset * TSP_data_channel_get_encoded_size(in_info->type);
 		  
 		  /* 2 - In the out symbol table */
Index: src/core/ctrl/tsp_provider.h
===================================================================
--- src/core/ctrl/tsp_provider.h	(révision 4)
+++ src/core/ctrl/tsp_provider.h	(révision 205)
@@ -88,10 +88,10 @@
 void  TSP_provider_request_sample_destroy(TSP_request_sample_destroy_t* req_sample_destroy, 
 					  TSP_answer_sample_destroy_t* ans_sample);
 
-int TSP_provider_is_initialized(void);
+int TSP_provider_is_initialized();
 
-int TSP_provider_get_server_number(void);
-int TSP_provider_get_server_base_number(void );
+int TSP_provider_get_server_number();
+int TSP_provider_get_server_base_number( );
 
 int TSP_provider_request_async_sample_write(TSP_async_sample_t* async_sample_write);
 
Index: src/core/ctrl/tsp_default_glu.h
===================================================================
--- src/core/ctrl/tsp_default_glu.h	(révision 4)
+++ src/core/ctrl/tsp_default_glu.h	(révision 205)
@@ -52,47 +52,47 @@
 
 /** 
  * Default GLU server name.
- * @param this the GLU object
+ * @param cthis the GLU object
  * @return GLU name.
  */
-char* GLU_get_server_name_default(GLU_handle_t* this);
+char* GLU_get_server_name_default(GLU_handle_t* cthis);
 
 /**
  * Default GLU server type.
- * @param[in] this the GLU object
+ * @param[in] cthis the GLU object
  * @return GLU server type.
  */
-GLU_server_type_t GLU_get_server_type_default(GLU_handle_t* this);
+GLU_server_type_t GLU_get_server_type_default(GLU_handle_t* cthis);
 
 /**
  * Default GLU base frequency.
- * @param[in] this the GLU object
+ * @param[in] cthis the GLU object
  * @return GLU base frequency (Hz)
  */
-double GLU_get_base_frequency_default(GLU_handle_t* this);
+double GLU_get_base_frequency_default(GLU_handle_t* cthis);
 
 int32_t 
-GLU_get_nb_max_consumer_default(struct GLU_handle_t* this);
+GLU_get_nb_max_consumer_default(struct GLU_handle_t* cthis);
 
 /**
  * Default GLU start.
- * @param[in] this the GLU object
+ * @param[in] cthis the GLU object
  * @return true or false
  */
 int32_t 
-GLU_start_default(GLU_handle_t* this);
+GLU_start_default(GLU_handle_t* cthis);
 
 /** 
  * Default GLU_get_pgi.
  * The default implementation use the mandatory GLU_get_sample_symbol_info_list
  * and does a linear search in it.
- * @param[in] this the GLU object 
+ * @param[in] cthis the GLU object 
  * @param[in] symbol_list the symbol list to validate
  * @param[out] pg_indexes array containing corresponding provider global indexes or -1 if not found 
  * @return TRUE if all symbol found, else return FALSE 
  */
 int32_t
-GLU_get_pgi_default(GLU_handle_t* this, 
+GLU_get_pgi_default(GLU_handle_t* cthis, 
 		    TSP_sample_symbol_info_list_t* symbol_list, 
 		    int* pg_indexes);
 
@@ -101,29 +101,29 @@
  * The default implementation is only valid for an ACTIVE GLU.
  * In this case this function always return this.
  * PASSIVE GLU should reimplement this function.
- * @param[in,out] this  the GLU object
+ * @param[in,out] cthis  the GLU object
  * @param[in] custom_argc
  * @param[in] custom_argv
  * @param[in,out] error_info
  * @return the GLU handle  
  */ 
 GLU_handle_t* 
-GLU_get_instance_default(GLU_handle_t* this,
+GLU_get_instance_default(GLU_handle_t* cthis,
 			 int custom_argc,
 			 char* custom_argv[],
 			 char** error_info);
 
 /**
  * Return the number of (static) available symbols.
- * @param[in] this the GLU object
+ * @param[in] cthis the GLU object
  * @return the number of (static) available symbols.
  */
 int32_t
-GLU_get_nb_symbols_default(GLU_handle_t* this);
+GLU_get_nb_symbols_default(GLU_handle_t* cthis);
 
 /**
  * Return the filtered list of sample symbols.
- * @param[in] this the GLU object
+ * @param[in] cthis the GLU object
  * @param[in] filter_kind the filter kind
  * @param[in] filter_string the filter string
  * @param[out] answer_sample the Answer Sample containing the list of symbols
@@ -131,27 +131,27 @@
  * @return the number of (static) available symbols.
  */
 int32_t
-GLU_get_filtered_ssi_list_default(GLU_handle_t* this, 
+GLU_get_filtered_ssi_list_default(GLU_handle_t* cthis, 
 				  int filter_kind, char* filter_string, 
 				  TSP_answer_sample_t* answer_sample);
 
 int32_t
-GLU_get_ssi_list_fromPGI_default(struct GLU_handle_t* this, 
+GLU_get_ssi_list_fromPGI_default(struct GLU_handle_t* cthis, 
 				 int* pgis, int pgis_len, 
 				 TSP_sample_symbol_info_list_t* SSI_list);
 
 int32_t
-GLU_get_ssei_list_fromPGI_default(struct GLU_handle_t* this, 
+GLU_get_ssei_list_fromPGI_default(struct GLU_handle_t* cthis, 
 				  int* pgis, int pgis_len, 
   				  TSP_sample_symbol_extended_info_list_t* SSEI_list);
 
 int32_t
-GLU_async_sample_read_default(struct GLU_handle_t* this, 
+GLU_async_sample_read_default(struct GLU_handle_t* cthis, 
 			      int pgi, 
 			      void* value_ptr, uint32_t* value_size);
 
 int32_t
-GLU_async_sample_write_default(struct GLU_handle_t* this, 
+GLU_async_sample_write_default(struct GLU_handle_t* cthis, 
 			       int pgi, 
 			       void* value_ptr, uint32_t value_size);
 
Index: src/core/ctrl/tsp_datapool.c
===================================================================
--- src/core/ctrl/tsp_datapool.c	(révision 4)
+++ src/core/ctrl/tsp_datapool.c	(révision 205)
@@ -37,6 +37,12 @@
 -----------------------------------------------------------------------
  */
 
+#ifdef WIN32
+    #define assert(exp)     ((void)0)
+#else
+    #include <assert.h>
+#endif
+
 #include <tsp_sys_headers.h>
 #include <tsp_datapool.h>
 #include <tsp_datastruct.h>
@@ -72,16 +78,15 @@
 
 
 void 
-TSP_datapool_get_reverse_list (TSP_datapool_t* datapool, int *nb, int **list) {
+TSP_datapool_get_reverse_list (TSP_datapool_t* this, int *nb, int **list) {
   assert(nb!=NULL);
   assert(list!=NULL);
-  assert(datapool);
-  *nb = datapool->nb_wanted_items;
-  *list = datapool->reverse_index;
+  assert(this);
+  *nb = this->nb_wanted_items;
+  *list = this->reverse_index;
 }
 
-
-inline int 
+int 
 TSP_datapool_push_next_item(TSP_datapool_t* datapool, glu_item_t* item) {
   assert(datapool);
   memcpy((*datapool).items[item->provider_global_index].raw_value,
Index: src/core/rpc/tsp_rpc_cleanup.c
===================================================================
--- src/core/rpc/tsp_rpc_cleanup.c	(révision 0)
+++ src/core/rpc/tsp_rpc_cleanup.c	(révision 205)
@@ -0,0 +1,95 @@
+/*
+
+$Header: /cvsroot/tsp/tsp/src/core/rpc/tsp_server.c,v 1.31 2006/05/03 21:16:38 erk Exp $
+
+-----------------------------------------------------------------------
+
+TSP Library - core components for a generic Transport Sampling Protocol.
+
+Copyright (c) 2002 Yves DUFRENNE, Stephane GALLES, Eric NOULARD and Robert PAGNOT 
+Copyright (c) 2005 Cesare BERTONA
+
+This library is free software; you can redistribute it and/or
+modify it under the terms of the GNU Lesser General Public
+License as published by the Free Software Foundation; either
+version 2.1 of the License, or (at your option) any later version.
+
+This library is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNULesser General Public License for more details.
+
+You should have received a copy of the GNU Lesser General Public
+License along with this library; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+-----------------------------------------------------------------------
+
+Project    : TSP
+Maintainer : tsp@astrium.eads.net
+Component  : Provider
+
+-----------------------------------------------------------------------
+
+Purpose   : 
+
+-----------------------------------------------------------------------
+*/
+
+
+#include <rpc/rpc.h>
+#include <stdio.h>
+#ifndef WIN32
+    #include <netdb.h>
+    #include <unistd.h> 
+    #include <rpc/pmap_clnt.h>
+#else
+    #include <rpc/pmap_cln.h>
+#endif
+
+#include <tsp_sys_headers.h>
+#include <tsp_glu.h>
+/* 
+ * FIXME RP : beurk, RPC is compiled before CTRL 
+ * could export this include, how should I call 
+ * Request Manager and GLU then ? 
+ * All our troubles comes from using tsp_rpc.h
+ * in tsp_datastruct.h
+ * As soon as we have clean IDL generator
+ * we will get rid of those circular include problem
+ * We need 2 passes compile here, 
+ * the first for IDL and the second for C compilation.
+ */
+#include "../ctrl/tsp_provider.h"
+#include "../ctrl/tsp_request_handler.h"
+/* same FIXME IDL <--> C dependency */
+#include "../common/tsp_common_macros.h"
+
+#include <tsp_server.h>
+#include <tsp_rpc.h>
+#include <tsp_rpc_confprogid.h>
+
+int main(void)
+{
+#if defined (WIN32)
+  WSADATA WSAData;
+#endif
+
+  int servernumber;
+
+#if defined (WIN32)
+  if (WSAStartup(MAKEWORD(2,2), &WSAData)) {
+	WSACleanup();
+    return -1;
+   }
+#endif
+
+  for(servernumber=0; servernumber<TSP_MAX_SERVER_NUMBER; servernumber++)
+    {
+      svc_unregister (TSP_get_progid(servernumber), TSP_RPC_VERSION_INITIAL);
+      pmap_unset (TSP_get_progid(servernumber), TSP_RPC_VERSION_INITIAL);
+    }
+#if defined (WIN32)
+    WSACleanup();
+#endif
+  return 0;
+}
Index: src/core/rpc/tsp_server.h
===================================================================
--- src/core/rpc/tsp_server.h	(révision 4)
+++ src/core/rpc/tsp_server.h	(révision 205)
@@ -49,11 +49,11 @@
  */
 
 
-int TSP_rpc_request(TSP_provider_request_handler_t* this);
-int TSP_rpc_request_config(TSP_provider_request_handler_t* this);
-void* TSP_rpc_request_run(TSP_provider_request_handler_t* this);
-int TSP_rpc_request_stop(TSP_provider_request_handler_t* this);
-char* TSP_rpc_request_url(TSP_provider_request_handler_t* this);
+int TSP_rpc_request(TSP_provider_request_handler_t* cthis);
+int TSP_rpc_request_config(TSP_provider_request_handler_t* cthis);
+void* TSP_rpc_request_run(TSP_provider_request_handler_t* cthis);
+int TSP_rpc_request_stop(TSP_provider_request_handler_t* cthis);
+char* TSP_rpc_request_url(TSP_provider_request_handler_t* cthis);
 
 /** @} end group TSP_RPCRequestHandlerLib */ 
 
Index: src/core/rpc/tsp_client.c
===================================================================
--- src/core/rpc/tsp_client.c	(révision 4)
+++ src/core/rpc/tsp_client.c	(révision 205)
@@ -87,7 +87,7 @@
 
   if(cl == (CLIENT *)0)
     {
-      STRACE_DEBUG(("ERROR : GLOBAL clnt_create failed for host %s", target_name));
+      STRACE_ERROR(("ERROR : GLOBAL clnt_create failed for host %s", target_name));
     }
   else
     {
Index: src/core/rpc/tsp_server.c
===================================================================
--- src/core/rpc/tsp_server.c	(révision 4)
+++ src/core/rpc/tsp_server.c	(révision 205)
@@ -37,10 +37,14 @@
 
 
 #include <rpc/rpc.h>
-#include <netdb.h>
-#include <rpc/pmap_clnt.h>
 #include <stdio.h>
-#include <unistd.h> 
+#ifndef WIN32
+    #include <netdb.h>
+    #include <unistd.h> 
+    #include <rpc/pmap_clnt.h>
+#else
+    #include <rpc/pmap_cln.h>
+#endif
 
 #include <tsp_sys_headers.h>
 #include <tsp_glu.h>
@@ -67,8 +71,6 @@
 void
 tsp_rpc_1(struct svc_req *rqstp, register SVCXPRT *transp) ;
 
-#ifndef TSP_RPC_CLEANUP
-
 #define TSP_URL_MAXLENGTH 256
 
 typedef struct {
@@ -254,14 +256,14 @@
   int rpcport = -1;
 
   /* look for a free port */
-  while(rpcport && config->server_number<TSP_MAX_SERVER_NUMBER)
+  while(rpcport && (config->server_number<TSP_MAX_SERVER_NUMBER))
     {
-      rpcport = getrpcport("localhost", TSP_get_progid(config->server_number), TSP_RPC_VERSION_INITIAL, IPPROTO_TCP);
+      rpcport = (int)getrpcport("localhost", TSP_get_progid(config->server_number), TSP_RPC_VERSION_INITIAL, IPPROTO_TCP);
       if(rpcport)
-	config->server_number++;
+	    config->server_number++;
     }
 
-  if(rpcport && config->server_number >= TSP_MAX_SERVER_NUMBER)
+  if(rpcport && (config->server_number >= TSP_MAX_SERVER_NUMBER))
       config->server_number = -1;
 
   return config->server_number;
@@ -314,8 +316,12 @@
   this->run                = TSP_rpc_request_run;
   this->stop               = TSP_rpc_request_stop;
   this->url                = TSP_rpc_request_url;
+#if defined (WIN32)
+  /* structure pthread_t different under Windows */
+  this->tid.p              = -1;
+#else
   this->tid                = (pthread_t)-1;
-
+#endif
   this->config_param       = calloc(1, sizeof(TSP_rpc_request_config_t));
 
   this->status             = TSP_RQH_STATUS_IDLE;
@@ -432,16 +438,3 @@
 
 }
 
-#else
-int main(void)
-{
-  int servernumber;
-  for(servernumber=0; servernumber<TSP_MAX_SERVER_NUMBER; servernumber++)
-    {
-      svc_unregister (TSP_get_progid(servernumber), TSP_RPC_VERSION_INITIAL);
-      pmap_unset (TSP_get_progid(servernumber), TSP_RPC_VERSION_INITIAL);
-    }
-  return 0;
-}
-
-#endif
Index: src/core/xmlrpc/tsp_xmlrpc_server.h
===================================================================
--- src/core/xmlrpc/tsp_xmlrpc_server.h	(révision 4)
+++ src/core/xmlrpc/tsp_xmlrpc_server.h	(révision 205)
@@ -49,11 +49,11 @@
  */
 
 
-int TSP_xmlrpc_request(TSP_provider_request_handler_t* this);
-int TSP_xmlrpc_request_config(TSP_provider_request_handler_t* this);
-void* TSP_xmlrpc_request_run(TSP_provider_request_handler_t* this);
-int TSP_xmlrpc_request_stop(TSP_provider_request_handler_t* this);
-char* TSP_xmlrpc_request_url(TSP_provider_request_handler_t* this);
+int TSP_xmlrpc_request(TSP_provider_request_handler_t* cthis);
+int TSP_xmlrpc_request_config(TSP_provider_request_handler_t* cthis);
+void* TSP_xmlrpc_request_run(TSP_provider_request_handler_t* cthis);
+int TSP_xmlrpc_request_stop(TSP_provider_request_handler_t* cthis);
+char* TSP_xmlrpc_request_url(TSP_provider_request_handler_t* cthis);
 
 /** @} end group TSP_XMLRPCRequestHandlerLib */ 
 
Index: src/core/ctrl_init/tsp_provider_init.c
===================================================================
--- src/core/ctrl_init/tsp_provider_init.c	(révision 4)
+++ src/core/ctrl_init/tsp_provider_init.c	(révision 205)
@@ -52,8 +52,20 @@
 int32_t 
 TSP_provider_init(GLU_handle_t* theGLU, int* argc, char** argv[]) {
 
+#if defined (WIN32)
+  WSADATA WSAData;
+#endif
+
   int32_t retcode = TSP_STATUS_OK;
 
+#if defined (WIN32)
+  if (WSAStartup(MAKEWORD(2,2), &WSAData)) {
+	WSACleanup();
+	retcode = TSP_STATUS_NOK;
+    return retcode;
+   }
+#endif
+
   retcode = TSP_provider_private_init(theGLU,argc, argv);
   
   /* Initialize tsp request handlers structures */
@@ -122,22 +134,28 @@
 
 
 void 
-TSP_provider_end(void) {
+TSP_provider_end() {
   /* TODO : call flush on streams */
 
   /* remove any published URL */
   {
+#if !defined (WIN32)
     char systemCmd[512];
     sprintf(systemCmd, "rm -f /tmp/TSP.%d", getpid());
     system(systemCmd);
+#endif
   }
 
   /* Call handlers end function */
   TSP_provider_rqh_manager_end();
+
+#if defined (WIN32)
+    WSACleanup();
+#endif
 } /* end of TSP_provider_end */
 
 void 
-TSP_provider_print_usage(void) {
+TSP_provider_print_usage() {
    printf(TSP_ARG_PROVIDER_USAGE"\n");
 } /* TSP_provider_print_usage */
 
@@ -163,9 +181,11 @@
 
 	      if(pub_mode & TSP_PUBLISH_URLS_FILE)
 		{
+#if !defined (WIN32)
 		  char systemCmd[512];
 		  sprintf(systemCmd, "echo \"%s\" > /tmp/TSP.%d", url, getpid());
 		  system(systemCmd);
+#endif
 		}
 
 	      if(pub_mode & TSP_PUBLISH_URLS_SNMP)
Index: src/core/ctrl_init/tsp_provider_init.h
===================================================================
--- src/core/ctrl_init/tsp_provider_init.h	(révision 4)
+++ src/core/ctrl_init/tsp_provider_init.h	(révision 205)
@@ -61,7 +61,7 @@
  * @param[in,out] argv You must provide the real argv before using it
  * @return TSP_STATUS_OK on success other code on failure.
  */
-int32_t
+_EXPORT_TSP_PROVIDER int32_t
 TSP_provider_init(GLU_handle_t* theGLU, int* argc, char** argv[]);
 
 /**
@@ -69,7 +69,7 @@
  * After this call the TSP provider library should
  * not be called anymore.
  */
-void 
+_EXPORT_TSP_PROVIDER void 
 TSP_provider_end(void);
 
 /**
@@ -98,7 +98,7 @@
  *       - 0x11 dynamic blocking mode, this function will block forever.
  * @return TSP_STATUS_OK on success other code on failure.
  */
-int32_t
+_EXPORT_TSP_PROVIDER int32_t
 TSP_provider_run(int spawn_mode);
 
 
@@ -121,7 +121,7 @@
  *       - 0x0100 publish to local SNMP agent (TODO).
  * @return String table or NULL.
  */
-char**
+_EXPORT_TSP_PROVIDER char**
 TSP_provider_urls(int pub_mode);
 
 
Index: src/core/common/tsp_decoder.h
===================================================================
--- src/core/common/tsp_decoder.h	(révision 4)
+++ src/core/common/tsp_decoder.h	(révision 205)
@@ -39,7 +39,7 @@
 #define _TSP_DECODER_H
 
 
-#include <tsp_abs_types.h>
+#include <tsp_prjcfg.h>
 #include <tsp_rpc.h>
 
 #define TSP_SIZEOF_ENCODED_DOUBLE RNDUP(sizeof(double))
@@ -200,14 +200,14 @@
  * @param[in] type data type to determine the decoder to use
  * @return The address of the decoder function for the data type
  */
-TSP_data_decoder_t TSP_data_channel_get_decoder(TSP_datatype_t type);
+_EXPORT_TSP_COMMON TSP_data_decoder_t TSP_data_channel_get_decoder(TSP_datatype_t type);
 
 /**
  * Get the size of an encoded data type coming from the data stream
  * @param[in] type data type to determine the data type size
  * @return The size of an encoded ddata for the data stream 
  */
-int32_t TSP_data_channel_get_encoded_size(TSP_datatype_t type);
+_EXPORT_TSP_COMMON int32_t TSP_data_channel_get_encoded_size(TSP_datatype_t type);
 
 /** @} */
 
Index: src/core/common/tsp_common_ssi.h
===================================================================
--- src/core/common/tsp_common_ssi.h	(révision 4)
+++ src/core/common/tsp_common_ssi.h	(révision 205)
@@ -40,6 +40,12 @@
 
 #include <tsp_prjcfg.h>
 #include <tsp_datastruct.h>
+#ifdef WIN32
+    #define assert(exp)     ((void)0)
+#else
+    #include <assert.h>
+#endif
+
 
 /**
  * @defgroup TSP_CommonLib_SSI Sample Symbol Information Library Handling
@@ -70,7 +76,7 @@
  * @param[in] phase the symbol phase
  * return the new tsp_sample_symbol_info_t
  */
-TSP_sample_symbol_info_t*
+_EXPORT_TSP_COMMON TSP_sample_symbol_info_t*
 TSP_SSI_new(const char* name,
 	    int32_t pgi,
 	    int32_t pgridx,
@@ -87,7 +93,7 @@
  * @param[in] ssi the symbols list to destruct
  * return  TSP_STATUS_OK if ok
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_SSI_delete(TSP_sample_symbol_info_t** ssi);
 
 /**
@@ -105,7 +111,7 @@
  * @param[in] phase the symbol phase
  * return  TSP_STATUS_OK if ok
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_SSI_initialize(TSP_sample_symbol_info_t* ssi,
 		   const char* name,
 		   int32_t pgi,
@@ -123,7 +129,7 @@
  * @param[in] ssi the symbols list to destruct
  * return  TSP_STATUS_OK if ok
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_SSI_finalize(TSP_sample_symbol_info_t* ssi);
 
 /**
@@ -136,7 +142,7 @@
  *                On return the initialized structure.
  * @return TSP_STATUS_OK on success
  */
-int32_t 
+_EXPORT_TSP_COMMON int32_t 
 TSP_SSI_initialize_default(TSP_sample_symbol_info_t* ssi);
 
 /**
@@ -146,7 +152,7 @@
  * @param[in] period the symbol period
  * return  TSP_STATUS_OK if ok
  */
-int32_t 
+_EXPORT_TSP_COMMON int32_t 
 TSP_SSI_initialize_request_minimal(TSP_sample_symbol_info_t* ssi,
 				   const char* name,
 				   int32_t period);
@@ -162,7 +168,7 @@
  * @param[in] phase the symbol phase
  * return  TSP_STATUS_OK if ok
  */
-int32_t 
+_EXPORT_TSP_COMMON int32_t 
 TSP_SSI_initialize_request_full(TSP_sample_symbol_info_t* ssi,
 				const char* name,
 				int32_t type,
@@ -181,7 +187,7 @@
  * @param[in]     src_ssi
  * return  TSP_STATUS_OK if ok 
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_SSI_copy(TSP_sample_symbol_info_t* dst_ssi, 
 	     const TSP_sample_symbol_info_t src_ssi);
 
@@ -191,7 +197,7 @@
  * @param[in]  nbSSI the number of SSI in the to be created in the list.
  * @return the allocated list on success NULL on failure.
  */
-TSP_sample_symbol_info_list_t*
+_EXPORT_TSP_COMMON TSP_sample_symbol_info_list_t*
 TSP_SSIList_new(int32_t nbSSI);
 
 /**
@@ -199,7 +205,7 @@
  * @param[in] ssi the symbols list to destruct
  * return  TSP_STATUS_OK if ok
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_SSIList_delete(TSP_sample_symbol_info_list_t** ssi);
 
 /**
@@ -212,7 +218,7 @@
  * @post ssil contains the description of a SSIList with 
  *       nbSSI symbols. Each item of the list has been default initialized. 
  */
-int32_t 
+_EXPORT_TSP_COMMON int32_t 
 TSP_SSIList_initialize(TSP_sample_symbol_info_list_t* ssil,
 		       int32_t nbSSI);
 
@@ -221,7 +227,7 @@
  * @param[in] ssil the symbols list to destruct
  * return  TSP_STATUS_OK if ok
  */
-int32_t 
+_EXPORT_TSP_COMMON int32_t 
 TSP_SSIList_finalize(TSP_sample_symbol_info_list_t* ssil);
 
 /**
@@ -230,15 +236,15 @@
  * @param[in] src_ssil the symbols list copy source
  * return  TSP_STATUS_OK if ok
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_SSIList_copy(TSP_sample_symbol_info_list_t* dst_ssil, 
 		 const TSP_sample_symbol_info_list_t  src_ssil);
 
 
-TSP_sample_symbol_info_t*
+_EXPORT_TSP_COMMON TSP_sample_symbol_info_t*
 TSP_SSIList_getSSI(TSP_sample_symbol_info_list_t ssil, uint32_t index);
 
-uint32_t
+_EXPORT_TSP_COMMON uint32_t
 TSP_SSIList_getSize(const TSP_sample_symbol_info_list_t ssil);
 
 /** @} */
Index: src/core/common/tsp_common_ssei.c
===================================================================
--- src/core/common/tsp_common_ssei.c	(révision 4)
+++ src/core/common/tsp_common_ssei.c	(révision 205)
@@ -43,6 +43,11 @@
 #include <tsp_const_def.h>
 #define TSP_COMMON_SSEI_C
 #include <tsp_common_ssei.h>
+#ifdef WIN32
+    #define assert(exp)     ((void)0)
+#else
+    #include <assert.h>
+#endif
 
 TSP_extended_info_t*
 TSP_EI_new(const char *key,const char *value) {
Index: src/core/common/tsp_common_as.c
===================================================================
--- src/core/common/tsp_common_as.c	(révision 4)
+++ src/core/common/tsp_common_as.c	(révision 205)
@@ -45,6 +45,11 @@
 #define TSP_COMMON_AS_C
 #include <tsp_common_as.h>
 #include <tsp_common_ssi.h>
+#ifdef WIN32
+    #define assert(exp)     ((void)0)
+#else
+    #include <assert.h>
+#endif
 
 TSP_answer_sample_t*
 TSP_AS_new(int32_t version_id,
@@ -86,8 +91,9 @@
 		  int32_t max_consumer_number,
 		  int32_t current_consumer_number,
 		  TSP_status_t status) {
-  assert(as);
+  
   int32_t retcode = TSP_STATUS_OK;
+  assert(as);
 
   as->version_id             = version_id;
   as->channel_id             = channel_id;
@@ -105,8 +111,9 @@
 
 int32_t
 TSP_AS_finalize(TSP_answer_sample_t* as) {
-  assert(as);
+  
   int32_t retcode = TSP_STATUS_OK;
+  assert(as);
   
   TSP_AS_initialize(as,
 		    TSP_UNDEFINED_VERSION_ID,
Index: src/core/common/tsp_encoder.c
===================================================================
--- src/core/common/tsp_encoder.c	(révision 4)
+++ src/core/common/tsp_encoder.c	(révision 205)
@@ -36,8 +36,7 @@
 -----------------------------------------------------------------------
  */
 
-
-#include <rpc/types.h>
+#include <rpc/rpc.h>
 #include <rpc/xdr.h>
 
 #include <tsp_const_def.h>
@@ -46,12 +45,25 @@
 #include <tsp_encoder.h>
 #include <tsp_decoder.h>
 
+#if defined (WIN32)
+    #include <malloc.h>
+    #define assert(exp)     ((void)0)
+#else
+    #include <assert.h>
+#endif
+
 uint32_t TSP_data_channel_double_encoder(void* v_double, uint32_t dimension,  char* out_buf, uint32_t size)
 {
 
   double *pt_double;
   uint32_t i,taille;
 
+#ifndef TSP_NO_XDR_ENCODE
+
+  XDR xhandle;
+
+#endif /*TSP_NO_XDR_ENCODE*/
+
   taille= sizeof(double) * dimension;
   if(size  < taille )
   {
@@ -62,9 +74,6 @@
   pt_double=(double*)v_double;
 
 #ifndef TSP_NO_XDR_ENCODE
-
-  XDR xhandle;
-  
  
   xdrmem_create(&xhandle, out_buf,  size, XDR_ENCODE);
 
@@ -102,6 +111,12 @@
   float *pt_float;
   uint32_t i,taille;
 
+#ifndef TSP_NO_XDR_ENCODE
+
+  XDR xhandle;
+
+#endif /*TSP_NO_XDR_ENCODE*/
+
   taille= sizeof(float) * dimension;
   if(size  < taille )
   {
@@ -113,9 +128,6 @@
 
 #ifndef TSP_NO_XDR_ENCODE
 
-  XDR xhandle;
-  
- 
   xdrmem_create(&xhandle, out_buf,  size, XDR_ENCODE);
 
   for(i=0;i<dimension;++i)
@@ -149,7 +161,7 @@
 
   int8_t *pt_int8;
   uint32_t i;
-  int32_t  temp[dimension];
+  int32_t*  temp = alloca(sizeof(int32_t)*dimension);
 
   pt_int8=(int8_t*)v_int8;
 
@@ -167,7 +179,7 @@
 {
   int16_t *pt_int16;
   uint32_t i;
-  int32_t  temp[dimension];
+  int32_t*  temp = alloca(sizeof(int32_t)*dimension);
 
   pt_int16=(int16_t*)v_int16;
 
@@ -183,6 +195,12 @@
   int32_t *pt_int32;
   uint32_t i,taille;
 
+#ifndef TSP_NO_XDR_ENCODE
+
+  XDR xhandle;
+
+#endif /*TSP_NO_XDR_ENCODE*/
+
   taille= TSP_SIZEOF_ENCODED_INT32 * dimension;
   if(size  < taille )
   {
@@ -194,9 +212,6 @@
 
 #ifndef TSP_NO_XDR_ENCODE
 
-  XDR xhandle;
-  
- 
   xdrmem_create(&xhandle, out_buf,  size, XDR_ENCODE);
 
   for(i=0;i<dimension;++i)
@@ -229,6 +244,12 @@
   int64_t *pt_int64;
   uint32_t i,taille;
 
+#ifndef TSP_NO_XDR_ENCODE
+
+  XDR xhandle;
+
+#endif /*TSP_NO_XDR_ENCODE*/
+
   taille= TSP_SIZEOF_ENCODED_INT64 * dimension;
   if(size  < taille )
   {
@@ -240,9 +261,6 @@
 
 #ifndef TSP_NO_XDR_ENCODE
 
-  XDR xhandle;
-  
- 
   xdrmem_create(&xhandle, out_buf,  size, XDR_ENCODE);
 
   for(i=0;i<dimension;++i)
@@ -275,7 +293,7 @@
 
   uint8_t *pt_uint8;
   uint32_t i;
-  uint32_t  temp[dimension];
+  uint32_t*  temp = alloca(sizeof(int32_t)*dimension);
 
   pt_uint8=(uint8_t*)v_uint8;
 
@@ -290,7 +308,7 @@
 {
   uint16_t *pt_uint16;
   uint32_t i;
-  uint32_t  temp[dimension];
+  uint32_t*  temp = alloca(sizeof(int32_t)*dimension);
 
   pt_uint16=(uint16_t*)v_uint16;
 
@@ -306,6 +324,12 @@
   uint32_t *pt_uint32;
   uint32_t i,taille;
 
+#ifndef TSP_NO_XDR_ENCODE
+
+  XDR xhandle;
+
+#endif /*TSP_NO_XDR_ENCODE*/
+
   taille= TSP_SIZEOF_ENCODED_UINT32 * dimension;
   if(size  < taille )
   {
@@ -317,9 +341,6 @@
 
 #ifndef TSP_NO_XDR_ENCODE
 
-  XDR xhandle;
-  
- 
   xdrmem_create(&xhandle, out_buf,  size, XDR_ENCODE);
 
   for(i=0;i<dimension;++i)
@@ -353,6 +374,12 @@
   uint64_t *pt_uint64;
   uint32_t i,taille;
 
+#ifndef TSP_NO_XDR_ENCODE
+
+  XDR xhandle;
+
+#endif /*TSP_NO_XDR_ENCODE*/
+
   taille= TSP_SIZEOF_ENCODED_UINT64 * dimension;
   if(size  < taille )
   {
@@ -364,9 +391,6 @@
 
 #ifndef TSP_NO_XDR_ENCODE
 
-  XDR xhandle;
-  
- 
   xdrmem_create(&xhandle, out_buf,  size, XDR_ENCODE);
 
   for(i=0;i<dimension;++i)
@@ -399,7 +423,7 @@
 {
   uint8_t *pt_char;
   uint32_t i;
-  uint32_t  temp[dimension];
+  uint32_t*  temp = alloca(sizeof(int32_t)*dimension);
 
   pt_char=(uint8_t*)v_char;
 
@@ -415,7 +439,7 @@
 
   uint8_t  *pt_uchar;
   uint32_t  i;
-  uint32_t  temp[dimension];
+  uint32_t*  temp = alloca(sizeof(int32_t)*dimension);
 
   pt_uchar=(uint8_t*)v_uchar;
 
@@ -431,7 +455,7 @@
 
   uint8_t *pt_user;
   uint32_t  i;
-  uint32_t  temp[dimension];
+  uint32_t*  temp = alloca(sizeof(int32_t)*dimension);
 
   pt_user=(uint8_t*)v_user;
 
